
% -------------------------------------------------------------------------
% FunIndex: Index of function.
% MaxIt: The maximum number of iterations.
% PopSize: The size of population.
% PopPos: The position of population.
% PopFit: The fitness of population.
% Dim: The dimensionality of prloblem. 
% Alpha: The weight coefficient in chain foraging.
% Beta: The weight coefficient in cyclone foraging.
% S: The somersault factor.
% BestF: The best fitness corresponding to BestX. 
% HisBestFit: History best fitness over iterations. 
% Low: The low bound of search space.
% Up: The up bound of search space.

function [BestX,BestF,HisBestFit]=CMRFO(F_index,MaxIt,nPop,Dim,Low,Up)

         pr=0.1;

    for i=1:nPop
        for j=1:Dim
            p=0.9;
            x(1)=0.6;
            x(i+1)=p*(1-x(i)^2);
            PopPos(i,j)=x(i+1).*(Up-Low)+Low;
        end
        PopFit(i)=F_index(PopPos(i,:));
    end
       BestF=inf;
       BestX=[];

    for i=1:nPop
        PopFit(i)=F_index(PopPos(i,:));
        if PopFit(i)<=BestF
           BestF=PopFit(i);
           BestX=PopPos(i,:);
        end
    end

       HisBestFit=zeros(MaxIt,1);


for It=1:MaxIt  
     Coef=It/MaxIt; 
     
       if rand<0.5
          r1=rand;                         
          Beta=2*exp(r1*((MaxIt-It+1)/MaxIt))*(sin(2*pi*r1));    
          if  Coef>rand                                                      
              newPopPos(1,:)=BestX+rand(1,Dim).*(BestX-PopPos(1,:))+Beta*(BestX-PopPos(1,:)); %Equation (4)
          else
              IndivRand=rand(1,Dim).*(Up-Low)+Low;                                
              newPopPos(1,:)=IndivRand+rand(1,Dim).*(IndivRand-PopPos(1,:))+Beta*(IndivRand-PopPos(1,:)); %Equation (7)         
          end              
       else 
            Alpha=2*rand(1,Dim).*(-log(rand(1,Dim))).^0.5;           
            newPopPos(1,:)=PopPos(1,:)+rand(1,Dim).*(BestX-PopPos(1,:))+Alpha.*(BestX-PopPos(1,:)); %Equation (1)
       end
     
    for i=2:nPop
        if rand<0.5
           r1=rand;                         
           Beta=2*exp(r1*((MaxIt-It+1)/MaxIt))*(sin(2*pi*r1));    
             if  Coef>rand                                                      
                 newPopPos(i,:)=BestX+rand(1,Dim).*(PopPos(i-1,:)-PopPos(i,:))+Beta*(BestX-PopPos(i,:)); %Equation (4)
             else
                 IndivRand=rand(1,Dim).*(Up-Low)+Low;                                
                 newPopPos(i,:)=IndivRand+rand(1,Dim).*(PopPos(i-1,:)-PopPos(i,:))+Beta*(IndivRand-PopPos(i,:));  %Equation (7)       
             end              
        else
            Alpha=2*rand(1,Dim).*(-log(rand(1,Dim))).^0.5;           
            newPopPos(i,:)=PopPos(i,:)+rand(1,Dim).*(PopPos(i-1,:)-PopPos(i,:))+Alpha.*(BestX-PopPos(i,:)); %Equation (1)
       end         
    end
         
           for i=1:nPop        
               newPopPos(i,:)=SpaceBound(newPopPos(i,:),Up,Low);
               newPopFit(i)= F_index(newPopPos(i,:));  
              if newPopFit(i)<PopFit(i)
                 PopFit(i)=newPopFit(i);
                 PopPos(i,:)=newPopPos(i,:);
              end
           end
     
            S=2;
        for i=1:nPop           
            newPopPos(i,:)=PopPos(i,:)+S*(rand*BestX-rand*PopPos(i,:)); %Equation (8)
        end
     
     for i=1:nPop        
         newPopPos(i,:)=SpaceBound(newPopPos(i,:),Up,Low);
         newPopFit(i)=F_index(newPopPos(i,:));  
         if newPopFit(i)<PopFit(i)
            PopFit(i)=newPopFit(i);
            PopPos(i,:)=newPopPos(i,:);
         end
     end
     
    for i=1:nPop
        if PopFit(i)<BestF
           BestF=PopFit(i);
           BestX=PopPos(i,:);            
        end
    end
    
    Ob_PopPos=Up+Low-PopPos;
    PopPos_Combine=[PopPos;Ob_PopPos];
    
    for i=1:size(PopPos_Combine,1)
        PopFit_Combine(i)=F_index(PopPos_Combine(i,:));  
    end
    
    [~,q]=sort(PopFit_Combine);
    for i=1:size(PopPos,1)
        newPopPos(i,:)=PopPos_Combine(q(i),:);
        newPopFit(i)=PopFit_Combine(q(i));
    end
    if newPopFit(i)<PopFit(i)
            PopFit(i)=newPopFit(i);
            PopPos(i,:)=newPopPos(i,:);
    end
    
    [~,q]=sort(PopFit);
    
    for i=1:pr*size(PopPos,1)  %go_pos(i,:) 
        Go_PopPos(i,:)=PopPos(q(i),:);
    end
    for j=1:size(PopPos,2)           %% һ㷴ѧϰ½
        a_bound(1,j)=min(Go_PopPos(:,j));
        b_bound(1,j)=max(Go_PopPos(:,j));
    end
    Go_PopPos=(Go_PopPos-Low)./(Up-Low); %% Ӣӳ䵽[01]
    for i=1:MaxIt
        Go_PopPos=4*Go_PopPos.*(1-Go_PopPos);    %% chaos
    end
    
    for i=1:pr*size(PopPos,1)        %% 1-3
        for j=1:size(PopPos,2)   	
            Go_PopPos(i,j)=Go_PopPos(i,j)*(b_bound(j)-a_bound(j))+a_bound(j);   
        end
    end
        
        for i=1:pr*size(PopPos,1)        
               newPopPos(i,:)=SpaceBound(Go_PopPos(i,:),Up,Low);
               newPopFit(i)=F_index(Go_PopPos(i,:));    
              if newPopFit(i)<PopFit(i)
                 PopFit(i)=newPopFit(i);
                 PopPos(i,:)=newPopPos(i,:);
              end
        end
        
    for i=1:nPop
        if PopFit(i)<BestF
           BestF=PopFit(i);
           BestX=PopPos(i,:);            
        end
    end
    
  
     HisBestFit(It)=BestF;
end