clear all
clc

Function_name="F1";
Max_iteration=1000;
SearchAgents_no=50;
[lb,ub,dim,fobj]=Get_Functions_details(Function_name);

[BestX,BestF,HisBestF]=CMRFO(fobj,Max_iteration,SearchAgents_no,dim,lb,ub);

figure('Position',[454   445   694   297]);
subplot(1,2,1);
func_plot(Function_name);
title('Parameter space')
xlabel('x_1');
ylabel('x_2');
zlabel([Function_name,'( x_1 , x_2 )'])

subplot(1,2,2);
semilogy(HisBestF,'Color','r','LineWidth',2)
title('Convergence curve')
xlabel('Iteration#');
ylabel('Best fitness function');
axis tight
legend('AOA')
grid on;

display(['The best-obtained solution by AOA is : ', num2str(BestX)]);
display(['The best optimal value of the objective funciton found by AOA is : ', num2str(BestF)]);


