%__________________________________________________________________
%   L\'evy flight distribution (LFD) source code 
%  programming: Mohammed R. Saad and Fatma A. Hashim
%
%  paper:
%  Essam H. Houssein, Mohammed R. Saad, Fatma A. Hashim, 
%  Hassan Shaban, and M. Hassaballah
%  L´evy Flight Distribution: A new metaheuristic algorithm for    %  solving engineering optimization problems
%  Engineering Applications of Artificial Intelligence
%  DOI: 
%  
%  E-mail: essam.halim@mu.edu.eg (Essam H. Houssein)
%  E-mail: m.saad@fci.svu.edu.eg (Mohammed R. Saad)
%  E-mail: fatma_hashim@h-eng.helwan.edu.eg (Fatma A. Hashim)
%  E-mail: hassan_sh_ha@yahoo.com (Hassan Shaban)
%  E-mail: m.hassaballah@svu.edu.eg (M. Hassaballah)
%__________________________________________________________________
close all
clear all 
clc 
max_iteration=1000;
searchAgents_no=35;
threshold=2;
Function_name='F2'; % Name of the test function that can be from F1 to F23
% Load details of the selected benchmark function
[lb,ub,dim,fobj]=Get_Functions_details(Function_name);
[Target_score,Target_position,Convergence_LFD]=LFD(searchAgents_no,max_iteration,threshold,lb,ub,dim,fobj);

% Convergence Curve
figure
semilogy(Convergence_LFD,'Color','r')
hold off
xlabel('Iteration');
ylabel('Best Score Obtained So Far');
xlim([1 1000]);
legend('LFD')
hold off
title('Convergence Curve'); 

